/*
 * Copyright European Organization for Nuclear Research (CERN)
 * All rights reserved
 *
 * Author:	Vasilis.Vlachoudis@cern.ch
 * Date:	01-Apr-2011
 */

#include <math.h>

#include "plane.h"

/** create a plane from 3 vertices */
void Plane::make(const Point& A, const Point& B, const Point& C)
{
	Vector AB = B - A;
	Vector AC = C - A;
	Vector ABxAC = AB ^ AC;
	ABxAC.normalize();
	a = ABxAC.x;
	b = ABxAC.y;
	c = ABxAC.z;
	d = - ABxAC * A;
	init();
	normalize();
} // make
