/**
 *
 * Author:	Vasilis.Vlachoudis@cern.ch
 * Date:	10-Dec-2018
 *
 * FIXME Maybe one can use std::set() or std::multiset() (if duplicates exist)
 */

#ifndef __TOOL_SORTVECTOR_H
#define __TOOL_SORTVECTOR_H

// Populate a sorted vector
#include <vector>
#include <algorithm>

template<typename T>
	typename std::vector<T>::iterator
insert_sorted(std::vector<T> & vec, T const& item)
{
	return vec.insert(
			std::upper_bound(vec.begin(), vec.end(), item),
			item);
}

template<typename T, typename Pred>
	typename std::vector<T>::iterator
insert_sorted(std::vector<T> & vec, T const& item, Pred pred)
{
	return vec.insert(
			std::upper_bound(vec.begin(), vec.end(), item, pred),
			item);
}

#endif
